#!/bin/sh
################################################################################
#                                                                              #
# Polish Koders Team 2010                                                      #
#                                                                              #
# contact: http://pkteam.pl                                                    #
#                                                                              #
################################################################################


#-------------------------------------------------------------------------------
#script section
#-------------------------------------------------------------------------------
howto()
{
 echo "_(NOTE: When wireless mode is enable LAN interface is down)"
 echo "_(If You need to re-use LAN interface You need to disable wireless support and restart tuner)" "\n"
 echo "_(If You want to use WLAN interface You need perform 4 steps:)"
 echo "_(1. Setup connection)"
 echo "_(2. Restart GUI)"
 echo "_(3. Setup WLAN network)"
 echo "_(4. Re/Start Wi-Fi network)" "\n"
 echo "_(You can check if connection has been established by running the option: 'connection status')"
}

rt3070_on()
{
 if [ ! -e /lib/modules/rt3070sta.ko ]; then
    echo "no wifi driver found, please download it from Blue Panel and try again"
 else
    echo wlan=rt3070 >/var/config/wlan.conf
    sync
    insmod /lib/modules/rt3070sta.ko
    ifconfig ra0 up
    echo "_(Ralink RT3070 driver loaded)" "\n"
    mac=`ifconfig ra0 | grep HWaddr | awk '{print $5}'`
    echo "_(Detected Wi-Fi MAC: )" $mac "\n"
    echo "_(IMPORTANT: You have to restart GUI or reboot IPBOX before setup: WLAN network configuration)" "\n"
    howto
 fi
}

rt2870_on()
{
 if [ ! -e /lib/modules/rt3070sta.ko ]; then
    echo "no wifi driver found, please download it from Blue Panel and try again"
 else
    echo wlan=rt2870 >/var/config/wlan.conf
    sync
    insmod /lib/modules/rt2870sta.ko
    ifconfig ra0 up
    echo "_(Ralink RT2870 driver loaded)" "\n"
    mac=`ifconfig ra0 | grep HWaddr | awk '{print $5}'`
    echo "_(Detected Wi-Fi MAC: )" $mac "\n"
    echo "_(IMPORTANT: You have to restart GUI or reboot IPBOX before setup: WLAN network configuration)" "\n"
    howto
 fi
}

wifi_off()
{
 echo wlan=off >/var/config/wlan.conf
 sync
 ifconfig ra0 down 2>/dev/null
 rmmod rt3070sta 2>/dev/null
 rmmod rt2870sta 2>/dev/null
 echo "_(Wi-Fi drivers deactivated)" "\n"
 echo "_(You can now use LAN interface after tuner reboot)"
}

network_restart()
{
 /etc/init.d/networking restart
}

#-------------------------------------------------------------------------------
#use section
#-------------------------------------------------------------------------------

case "$1" in
 'rt3070')
    rt3070_on
    ;;
 'rt2870')
    rt2870_on
    ;;
 'off')
    wifi_off
    ;;
 'restart')
    network_restart
    ;;
 *)
    echo -e "\nUse: wlan.sh rt3070|rt2870|off|restart"
    ;;
esac

echo ""
exit 0
